(function () {
    "use strict";

    angular.module('core').controller('grupoComposicaoImpostoDetailController', controller);
    controller.$inject = ['$scope', '$timeout', '$state', '$stateParams', 'grupoComposicaoImpostoService', 'lookupService', '$q'];

    function controller($scope, $timeout, $state, $stateParams, grupoComposicaoImpostoService, lookupService, $q) {
        $scope.initializeLayout('Grupo de Composição de Imposto');

        //[Inicializa objetos]
        $scope.state = {
            item: { ID: decodeURIComponent($stateParams.id) },
            carregando: false,
            vazio: false,
            tabCorrente: 0,
            tabs: {
                Detalhes: 0, 
                Composicoes: 1,
                Produtos: 2,
            },
        };

        $scope.addProduto = function () {
            debugger
            if (!$scope.auxiliar?.produtoSelecionado?.ID)
                return;
            var produto = []
            if ($scope.state.item.Produtos != null)
                produto = $scope.state.item.Produtos.filter(a => a.ID == $scope.auxiliar.produtoSelecionado.ID)
            else
                $scope.state.item.Produtos = [];
            if (produto.length == 0) {
                $scope.state.item.Produtos.push({
                    ID: $scope.auxiliar.produtoSelecionado.ID,
                    Codigo: $scope.auxiliar.produtoSelecionado.Codigo,
                    Nome: $scope.auxiliar.produtoSelecionado.Nome,
                    Deleted: false
                });
            }
            else {
                produto[0].Deleted = false;
            }
            $scope.auxiliar.produtoSelecionado = {};
        }

        $scope.addComposicao = function () {
            if (!$scope.auxiliar?.composicaoSelecionada?.ID)
                return;
            debugger
            var composicao = []
            if ($scope.state.item.ComposicoesImposto != null)
                composicao = $scope.state.item.ComposicoesImposto.filter(a => a.ID == $scope.auxiliar.composicaoSelecionada.ID)
            else
                $scope.state.item.ComposicoesImposto = [];
            if (composicao.length == 0) {
                $scope.state.item.ComposicoesImposto.push({
                    ID: $scope.auxiliar.composicaoSelecionada.ID,
                    Codigo: $scope.auxiliar.composicaoSelecionada.Codigo,
                    Nome: $scope.auxiliar.composicaoSelecionada.Nome,
                    Deleted: false
                });
            }
            else {
                composicao[0].Deleted = false;
            }
            $scope.auxiliar.composicaoSelecionada = {};
        }


        $scope.auxiliar = {
            produtoSelecionado: {},
            composicaoSelecionada: {},
            produto: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllProduto({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            composicao: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllComposicaoImposto({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            }
        }

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };
        $scope.save = function () {
            $scope.state.salvando = true;
            grupoComposicaoImpostoService
                .save($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.state.salvando = false;
                            $alert({ text: response.Message, title: $scope.Title });
                        } else {
                            $scope.historyBack();
                        }
                        $scope.state.salvando = false;
                    },
                    function (_error) {
                        $scope.state.salvando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    });
        };

        $scope.getTextDelete = function () {
            if ($scope.state.item.ComposicoesImposto != null && $scope.state.item.ComposicoesImposto.length > 0
                && $scope.state.item.Produtos != null && $scope.state.item.Produtos.length > 0)
                return "Este grupo possui produtos e/ou composições vinculadas. Ao excluí-lo, todas essas associações serão automaticamente removidas, e as composições atualmente vinculadas passarão a ser válidas para todos os produtos."
            else return ""
        }
        $scope.delete = function () {
            debugger
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            grupoComposicaoImpostoService
                .delete($scope.state.item.ID)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $alert({ text: response.Message, title: $scope.Title });
                        }
                        else {
                            $scope.historyBack();
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                    }
                );
        }
        $scope.get = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            grupoComposicaoImpostoService
                .get($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.item = response.Data;
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.refresh = function () {
            $scope.get();
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();